@echo off

REM //==============================================================================
REM /**
REM * @file    conv_swf10.bat
REM * @brief   swf6～swf8のファイルを、swf10に変換するコンバーター
REM * @author  com04
REM * @date    2012-08-22
REM */
REM //==============================================================================


setlocal enabledelayedexpansion

rem swfmill.exeがあるパス。ディレクトリの区切りは\\で。
set SWFMILL_PATH="D:\\workspace\\tools\\swfmill-0.3.2- win32\\swfmill.exe"


rem 引数のファイルを繰り返す
for %%i in (%*) do (
  set SWF_FILE=%%~i
  set SWF_TMP_FILE=%%~i.tmp
  set XML_FILE=%%~dpni.xml
  set XML_TMP_FILE=%%~dpni.tmp.xml
  set BACKUP_FILE=%%~i.back
  
  @echo on
  echo Convert File: !SWF_FILE!
  @echo off
  
  rem SWFファイルからXMLを作成
  %SWFMILL_PATH% swf2xml "!SWF_FILE!" "!XML_FILE!"
  if errorlevel 1 (
    @echo on
    echo [ERROR] Can't Convert swf to xml File.
    @echo off
    
    goto ERROR
  )

  rem コンバートするのに必要な文字列を置き換える
  type nul>"!XML_TMP_FILE!"
  set swf_conv=0
  set file_attributes_conv=0
  for /f "usebackq delims=" %%j in ("!XML_FILE!") do (
    rem 変換に必要なタグがあるか検索
    set str=%%j
    
    rem swfタグ
    echo "%%j" | find "<swf" >nul
    if not errorlevel 1 (
      rem バージョンの変更。暫定処置で再考の余地有り
      if not "!str:6=!" == "!str!" set swf_conv=1
      if not "!str:7=!" == "!str!" set swf_conv=1
      if not "!str:8=!" == "!str!" set swf_conv=1
      
      if !swf_conv! == 1 (
        set str=!str:6=10!
        set str=!str:7=10!
        set str=!str:8=10!
        @echo on
        echo   swf tag changed
        @echo off
      )
    )
    
    rem FileAttributesタグが有り、allowABCが無い場合
    echo "%%j" | find "<FileAttributes" >nul
    if not errorlevel 1 (
      echo "%%j" | find "allowABC" >nul
      if errorlevel 1 (
        set str=!str:hasMetaData=allowABC="1" hasMetaData!
        set file_attributes_conv=1
        @echo on
        echo   FileAttributes tag changed
        @echo off
      )
    )
    
    
    rem 一時ファイルに出力
    echo !str!>>"!XML_TMP_FILE!"
  )

  rem タグ変換したのなら
  if not !swf_conv! == 0 (
    if not !file_attributes_conv! == 0 (
      rem 書き換えたXMLからSWFを生成する
      %SWFMILL_PATH% xml2swf "!XML_TMP_FILE!" "!SWF_TMP_FILE!"
      if errorlevel 1 (
        @echo on
        echo [ERROR] Can't Convert xml to swf File.
        @echo off
        
        goto ERROR
      )
      rem 念のためバックアップ
      copy "!SWF_FILE!" "!BACKUP_FILE!"
      copy "!SWF_TMP_FILE!" "!SWF_FILE!"
    )
  )


  rem 中間ファイル削除
  if exist "!SWF_TMP_FILE!" del "!SWF_TMP_FILE!"
  if exist "!XML_TMP_FILE!" del "!XML_TMP_FILE!"
  if exist "!XML_FILE!" del "!XML_FILE!"
)


goto END

:ERROR
@echo on
echo Error Stoped!!!!

:END

endlocal

@echo on
pause

exit /b


